MWAWPictBitmapIndexed Class Referencefinal

a bitmap of int to store indexed bitmap More...

`#include <MWAWPictBitmap.hxx>`

Inheritance diagram for MWAWPictBitmapIndexed:

## Public Member Functions

SubType | getSubType () const final
| return the picture subtype
int | cmp (MWAWPict const &a) const final
| a virtual function used to obtain a strict order, must be redefined in the subs class
bool | valid () const final
| returns true if the picture is valid
MWAWColor | getAverageColor () const final
| returns the average color
| MWAWPictBitmapIndexed (MWAWVec2i const &sz)
| the constructor
MWAWVec2i const & | size () const
| the picture size
int | numRows () const
| the number of rows
int | numColumns () const
| the number of columns
int | get (int i, int j) const
| returns a cell content
int const * | getRow (int j) const
| returns the cells content of a row
void | set (int i, int j, int v)
| sets a cell contents
template<class U>
void | setRow (int j, U const *val)
| sets all cell contents of a row
template<class U>
void | setColumn (int i, U const *val)
| sets all cell contents of a column
std::vector< MWAWColor > const & | getColors () const
| returns the array of indexed colors
void | setColors (std::vector< MWAWColor > const &cols)
| sets the array of indexed colors
Public Member Functions inherited from MWAWPictBitmap
| ~MWAWPictBitmap () override
| destructor
Type | getType () const override
| returns the picture type
bool | getBinary (MWAWEmbeddedObject &picture) const override
| returns the final picture
Public Member Functions inherited from MWAWPict
virtual | ~MWAWPict ()
| virtual destructor
MWAWBox2f | getBdBox () const
| returns the bdbox of the picture
void | setBdBox (MWAWBox2f const &box)
| sets the bdbox of the picture

## Protected Member Functions

bool | createFileData (librevenge::RVNGBinaryData &result) const final
| the function which creates the result file
Protected Member Functions inherited from MWAWPictBitmap
| MWAWPictBitmap (MWAWVec2i const &sz)
| protected constructor: use check to construct a picture
Protected Member Functions inherited from MWAWPict
void | extendBDBox (float val)
| udaptes the bdbox, by extended it by (val-previousVal)
| MWAWPict ()
| protected constructor must not be called directly
| MWAWPict (MWAWPict const &p)
| protected constructor must not be called directly
MWAWPict & | operator= (MWAWPict const &p)
| protected operator= must not be called directly

## Protected Attributes

MWAWPictBitmapContainer< int > | m_data
| the m_data
std::vector< MWAWColor > | m_colors
| the colors

## Additional Inherited Members

Public Types inherited from MWAWPictBitmap
enum | SubType { BW , Indexed , Color }
| the picture subtype: blackwhite, indexed, color More...
Public Types inherited from MWAWPict
enum | Type { PictData , Bitmap , Unknown }
| the different picture types: More...
enum | ReadResult { MWAW_R_BAD =0 , MWAW_R_OK , MWAW_R_OK_EMPTY , MWAW_R_MAYBE }
| an enum to defined the result of a parsing use by some picture's classes which can read their data More...
Static Protected Member Functions inherited from MWAWPict
static MWAWBox2f | getBdBox (int numPt, MWAWVec2f const *pt)
| computes the minimum and maximum of a list of point

## Detailed Description

a bitmap of int to store indexed bitmap

## Constructor & Destructor Documentation

## MWAWPictBitmapIndexed()

MWAWPictBitmapIndexed::MWAWPictBitmapIndexed | ( | MWAWVec2i const & | sz | ) |

inline explicit

the constructor

Referenced by cmp(), and MWAWPictBitmapIndexed().

## Member Function Documentation

## cmp()

int MWAWPictBitmapIndexed::cmp | ( | MWAWPict const & | a | ) | const

inline final virtual

a virtual function used to obtain a strict order, must be redefined in the subs class

Reimplemented from MWAWPictBitmap.

## createFileData()

bool MWAWPictBitmapIndexed::createFileData | ( | librevenge::RVNGBinaryData & | result | ) | const

final protected virtual

the function which creates the result file

Implements MWAWPictBitmap.

## get()

int MWAWPictBitmapIndexed::get | ( | int | i,
|  | int | j ) const

inline

returns a cell content

## getAverageColor()

MWAWColor MWAWPictBitmapIndexed::getAverageColor | ( |  | ) | const

final virtual

returns the average color

Implements MWAWPictBitmap.

## getColors()

std::vector< MWAWColor > const & MWAWPictBitmapIndexed::getColors | ( |  | ) | const

inline

returns the array of indexed colors

## getRow()

int const * MWAWPictBitmapIndexed::getRow | ( | int | j | ) | const

inline

returns the cells content of a row

Referenced by getAverageColor().

## getSubType()

SubType MWAWPictBitmapIndexed::getSubType | ( |  | ) | const

inline final virtual

return the picture subtype

Implements MWAWPictBitmap.

## numColumns()

int MWAWPictBitmapIndexed::numColumns | ( |  | ) | const

inline

the number of columns

## numRows()

int MWAWPictBitmapIndexed::numRows | ( |  | ) | const

inline

the number of rows

## set()

void MWAWPictBitmapIndexed::set | ( | int | i,
|  | int | j,
|  | int | v )

inline

sets a cell contents

Referenced by ApplePictParserInternal::Pixmap::get(), MacDraft5StyleManagerInternal::Pixmap::get(), CanvasGraph::getBitmap(), DrawTableParser::getBitmap(), CanvasGraph::getBitmapBW(), ScoopParser::readBitmap(), CanvasGraph::readFileBitmap(), ClarisDrawGraph::sendBitmap(), and ClarisWksGraph::sendBitmap().

## setColors()

void MWAWPictBitmapIndexed::setColors | ( | std::vector< MWAWColor > const & | cols | ) |

inline

sets the array of indexed colors

Referenced by ApplePictParserInternal::Pixmap::get(), MacDraft5StyleManagerInternal::Pixmap::get(), MWAWGraphicStyle::Pattern::getBinary(), CanvasGraph::getBitmap(), DrawTableParser::getBitmap(), CanvasGraph::getBitmapBW(), MsWksGraphInternal::DataBitmap::getPictureData(), ScoopParser::readBitmap(), MacDrawProStyleManager::readColorPatterns(), CanvasGraph::readFileBitmap(), CorelPainterParser::readResource(), ClarisDrawGraph::sendBitmap(), and ClarisWksGraph::sendBitmap().

## setColumn()

template<class U>

void MWAWPictBitmapIndexed::setColumn | ( | int | i,
|  | U const * | val )

inline

sets all cell contents of a column

## setRow()

template<class U>

void MWAWPictBitmapIndexed::setRow | ( | int | j,
|  | U const * | val )

inline

sets all cell contents of a row

Referenced by MWAWGraphicStyle::Pattern::getBinary(), MsWksGraphInternal::DataBitmap::getPictureData(), MacDrawProStyleManager::readColorPatterns(), and CorelPainterParser::readResource().

## size()

MWAWVec2i const & MWAWPictBitmapIndexed::size | ( |  | ) | const

inline

the picture size

## valid()

bool MWAWPictBitmapIndexed::valid | ( |  | ) | const

inline final virtual

returns true if the picture is valid

Reimplemented from MWAWPictBitmap.

Referenced by ApplePictParserInternal::Pixmap::get(), and MacDraft5StyleManagerInternal::Pixmap::get().

## Member Data Documentation

## m_colors

std::vector<MWAWColor> MWAWPictBitmapIndexed::m_colors

protected

the colors

Referenced by cmp(), createFileData(), getAverageColor(), getColors(), MWAWPictBitmapIndexed(), and setColors().

## m_data

MWAWPictBitmapContainer<int> MWAWPictBitmapIndexed::m_data

protected

the m_data

Referenced by cmp(), createFileData(), get(), getAverageColor(), getRow(), MWAWPictBitmapIndexed(), numColumns(), numRows(), set(), setColumn(), setRow(), size(), and valid().

The documentation for this class was generated from the following files:

- MWAWPictBitmap.hxx
- MWAWPictBitmap.cxx